class MapNotSquareException(Exception):
    pass

class  PieceNotSquareException(Exception):
    pass

class save_Parser:
    def __init__(self, filename:str ):
        self.filename = filename
        self.map_shape = [[0]]
        self.pieces = list()

    def define_map(self, map_shape):
        size = len(map_shape)
        for row in map_shape:
            if size != len(row):
                raise MapNotSquareException
        self.map_shape = map_shape

    def add_piece(self, piece_shape):
        size = len(piece_shape)
        for row in piece_shape:
            if size != len(row):
                raise PieceNotSquareException
        self.pieces.append(piece_shape)

    def __str__(self):
        return str(self.map_shape)

    def shape_to_bytes(self, shape):
        bytes_ammount = len(shape) // 8
        bytes_trash = len(shape) % 8
        tray = 0

    def load(self):
        """
        load the file and prepare to parse informations
        """

    def save(self):
        """
        save parsed info to the file
        """
        save_data = b''
        save_data += b'SMS'
        save_data += bytes(len(map_shape))
        save_data += shape_to_bytes(self.map_shape)
        save_data += bytes()
        save_data += b'SME'
        with open(self.filename, mode='bw') as file:
            file.write(save_data)

if __name__ == "__main__":
    p = save_Parser('test.map')
    p.define_map([[0,1],[0,1]])
    p.save()
